/*
 * Header file for screen editor
 */

#ifndef FORMATTER

#define MEM_MAX		30000	/* Maximum amount of memory which the editor attempts to use */
#define IBSIZE		50	/* Insert buffer size */

#define	STATUS	0		/* Status line */
#define TGETPOS 5		/* X position for getting input line */
#define SEDLINESIZE	90	/* Max line we can input */

#define CLREOL	"\033T"
#define DELLINE	"\033R"
#define CLRSCRN	"\033*"
#define INSLIN	"\033E"
#define CLREOS	"\033Y"
#define MVCURS1	'\033'
#define MVCURS2	'='

#ifdef applix1616
#define opchar(ch)	PUTCHAR(ch)
#else
#define opchar(ch) putchar(ch)
#endif

#define MASK(x) (x & 0x7f)
#define INDEX maskindex
#define STRNCMP maskstrncmp
unsigned char	*maskindex();

#define CTL(c) ((c) & 0x1f)
#define ALT(c) ((c) | 0x80)

/* Masks for attributes */
#define SUBSCRIPT	1
#define SUPERSCRIPT	2
#define BOLD		4
#define UNDERLINE	8
#define WIDE		0x10		/* No on-screen support */
#define ITALICS		0x40

/* Justification modes */
#define J_RIGHT		0
#define J_RAGGED	1
#define J_CENTRE	2
#define J_MAX		3		/* Number of modes */

#endif

/* Imbedded control codes for attributes: pretty WS-like */
#define CC_BOLD		(CTL('B'))
#define CC_UNDERLINE	(CTL('S'))
#define CC_ITALICS	(CTL('Y'))
#define CC_SUBSCRIPT	(CTL('V'))
#define CC_SUPERSCRIPT	(CTL('T'))
#define CC_WIDE		(CTL('W'))
#define CC_USER1	(CTL('E'))
#define CC_USER2	(CTL('Q'))
#define CC_USER3	(CTL('R'))

/* A structure representing previously edited files */
struct oldFile
{
	char name[32];
	long markers[10];
	long blkstart;
	long blkend;
	int blkset;
	int cur_ptr;
	int hilitestart;
	int hiliteend;
	int tabwidth;
	int beingEdited;
	int spare[8];
};

#define CAPTURESIZE	256

struct sr_data
{
	char new[SEDLINESIZE];
	char old[SEDLINESIZE];
	int useregexp;
	int reverse;
	int ignorecase;
	int fromtop;
	int wrap;
	int ntimes;
	int initialised;
};

int findOldFile();
char *roll();
char *roomfor();
void *Malloc();
void *Realloc();
void sedterm();
