;
; Move a block of memory.
;
; Usage: _movmem(from, to, length)
;	 char *from, *to;
;	 long length;
;

		psect	text
		global	_movmem
;		global	_bmove
_movmem:
;_bmove:
		move.l	12(sp),d1
		beq.b	moveexit
		move.l	4(sp),a0	; From
		move.l	8(sp),a1	; To
		move.l	a1,d0
		cmp.l	a0,d0		; To - from. Carry clear if To >= From
		beq.b	moveexit		; Zero distance
		bcs.b	movedown

; Move memory higher. Start at end of block

		add.l	d1,a0
		add.l	d1,a1

		subq.l	#1,d1
		swap	d1		; Pre-swap
moveu2:		swap	d1
moveup:		move.b	-(a0),-(a1)
		dbf	d1,moveup
		swap	d1
		dbf	d1,moveu2

moveexit:	rts

movedown:	subq.l	#1,d1
		swap	d1		; Pre-swap
moved3:		swap	d1
moved2:		move.b	(a0)+,(a1)+
		dbf	d1,moved2
		swap	d1
		dbf	d1,moved3
		rts


;clearmem(addr, nbytes)
		global	_clearmem
_clearmem:	move.l	4(sp),a0	; Address
		move.l	8(sp),d1	; Count
		moveq.l	#0,d0
		bra	dobset
;
; Set memory bytes
;
; Usage: _bsetmem(address, val, count)
;	char *address;
;	long val;
;	long count;
;
		global	_bsetmem
_bsetmem:	move.l	4(sp),a0	; Address
		move.w	10(sp),d0	; Value
		move.l	12(sp),d1	; Count
dobset:
		bra.b	btst0
bset2:		swap	d1
bnot0:		move.b	d0,(a0)+
btst0:		dbf	d1,bnot0
		swap	d1		; Get upper 16 bits
		dbf	d1,bset2
		rts

		global	_splatr
_splatr:
		move.l	a2,-(sp)
		move.l	d2,-(sp)
		move.l	12(sp),a0		; icp
		move.l	16(sp),a1		; ocp
		move.l	20(sp),a2		; ecp
		move.b	#13,d1
		clr.l	d2

		bra		2f
1:
		move.b	(a0)+,d0		; read a char
		cmp.b	d1,d0			; '\r'?
		beq		3f				; yes: skip
		move.b	d0,(a1)+		; no: copy the char
		cmp.l	a0,a2
		bne		1b
		bra		2f
3:
		moveq.l	#1,d2			; record the fact that a \r has been seen
2:
		cmp.l	a0,a2
		bne		1b
		move.l	24(sp),a0
		move.l	d2,(a0)
		move.l	a1,d0			; return value
		move.l	(sp)+,d2
		move.l	(sp)+,a2
		rts

