/* ex: set ts=4 sw=4 */

#include "../sedit.h"

/*
 * Code for capturing/replaying keystrokes
 */

static unsigned char _buf1[CAPTURESIZE], _buf2[CAPTURESIZE];
static unsigned char *capturebuf, *replaybuf;
static int captureindex = 0;
static int replaysize = 0;

captureinit()
{
	capturebuf = _buf1;
	replaybuf = _buf2;
}

/* Put a keystroke in the capture buffer */
capture(c)
unsigned char c;
{
	if (captureindex < CAPTURESIZE)
		capturebuf[captureindex++] = c;
}

/*
 * A non-capturable key has been hit: save the capture buffer
 */

stopcapture()
{
	unsigned char *temp;

	if (captureindex)
	{
		temp = capturebuf;
		capturebuf = replaybuf;
		replaybuf = temp;
		replaysize = captureindex;
		captureindex = 0;
	}
}

/*
 * Replay the captured keystrokes in response to a ^K. command.
 */

replaycapture()
{
	int index;
	for (index = 0; index < replaysize; index++)
		sendtome(replaybuf[index]);
}
