/* TABS4 */

/*
 * Test dde_ipc communications
 */

#include <dde_ipc.h>
#include <syscalls.h>

char *ourname;

void
usage()
{
	FPRINTF(STDERR, "Usage: %s DDE_PID -l line\r\n", ourname);
	FPRINTF(STDERR, "       %s DDE_PID -f file\r\n", ourname);
	FPRINTF(STDERR, "       %s DDE_PID -c command\r\n", ourname);
	EXIT(-1);
}

main(int argc, char *argv[])
{
	int pid;
	char *pathname;
	int line;
	char *string;
	int mode;
	dde_ipc di;
	int ret;

	ourname = argv[0];
	if (argc != 4)
		usage();

	pid = atoi(argv[1]);
	if (!pid)
		usage();

	if (!strcmp(argv[2], "-l"))
	{
		line = atoi(argv[3]);
		mode = DDE_LINE;
	}
	else if (!strcmp(argv[2], "-f"))
	{
		pathname = argv[3];
		mode = DDE_FILE;
	}
	else if (!strcmp(argv[2], "-c"))
	{
		string = argv[3];
		mode = DDE_COMMAND;
	}
	else
		usage();

	di.mode = mode;
	switch (mode)
	{
	case DDE_FILE:
		strcpy(di.arg.pathname, pathname);
		break;
	case DDE_LINE:
		di.arg.lineno = line;
		break;
	case DDE_COMMAND:
		strcpy(di.arg.string, string);
		break;
	}

	ret = BLOCKTX(pid, &di, sizeof(di), 1);
	if (ret < 0)
		FPRINTF(STDERR, "BLOCKTX() failed: %s\r\n", ERRMES(ret));
	EXIT(ret);
}

