/*	TABS4
 * Help functions
 */

#include "../sedit.h"

#define ASIZE(array) (sizeof(array)/sizeof(*array))

extern int width, height;
extern int romver;

char *qmenu[] = {
	"^QA:   Substitute text",
	"^QB:   Go to block start",
	"^QC:   Go to end of file",
	"^QD:   Go forward to end of line",
	"^Q!D:  Go forward 80 chars",
	"^QE:   Go to top of screen",
	"^QF:   Find a pattern",
	"^QG:   Go to line number",
	"^QH:   Help screen",
	"^QK:   Go to block end",
	"^QL:   Find text under cursor",
	"^QP:   Go to previous place",
	"^QR:   Go to start of file",
	"^QS:   Go back to start of line",
	"^Q!S:  Go back 80 chars",
	"^QT:   Set tab width",
	"^QU:   Review undo buffers",
	"^QV:   Goto next instance of tag",
	"^QX:   Go to bottom of screen",
	"^QY:   Delete to end of line",
	"^Q?:   Display this screen",
	"^Q]:   Go to next C function",
	"^Q[:   Go to previous C function",
	"^Q%:   Go to matching (), {}, [] or #if/#endif",
	"^Q0 - ^Q9: Go to place markers 0 to 9"
	};

char *kmenu[] = {
	"^K=:   Write & switch to previous file",
	"^K<:   Remove one level of indent from marked block",
	"^K>:   Add one level of indent to marked block",
	"^K!:   Merge output of system command",
	"^K.:   Replay capture buffer",
	"^KA:   Edit another file",
	"^KB:   Mark block start",
	"^KC:   Copy marked block",
	"^KX:   Write file out and quit",
	"^KD:   Write file out, continue editing",
	"^KE:   Escape to 1616/OS for one command",
	"^KF:   Freeze the screen at cursor position",
	"^KG:   Edit file named by marked block",
	"^KH:   Set/clear highlighting of marked block",
	"^KI:   Escape to 1616/OS for multiple commands",
	"^KK:   Mark block end",
	"^KN:   Edit a new file",
	"^KO:   Reformat paragraphs within marked block",
	"^KP:   Put marked block into undo buffer",
	"^KQ:   Quit without writing",
	"^KR:   Read a file at cursor position",
	"^KS:   Toggle status line display",
	"^Kt:   Goto a tag defined in index file",
	"^KT:   Goto next occurrence of previous tag",
	"^Ku:   Convert marked block to lower case",
	"^KU:   Convert marked block to upper case",
	"^KV:   Move marked block to cursor position",
	"^KW:   Write marked block to a file",
	"^KY:   Delete the marked block",
	"^K?:   Display this screen",
	"^K0 - ^K9: Set place markers 0 to 9"
	};

char *omenu[] = {
	"^O :   Complete current word with reverse search",
	"^O@:   Display roll file list",
	"^O(:   Go to start of this C block",
	"^O(:   Go end start of this C block",
	"^OA:   Toggle auto-format mode",
	"^OB:   Rotate backwards through files",
	"^OC:   Centre the current line",
	"^OD:   Toggle control/attribute display",
	"^OE:   Go to start of previous paragraph",
	"^OF:   Rotate forwards through files",
	"^OI:   Toggle overstrike/insert mode",
	"^OJ:   Toggle justification mode",
	"^OL:   Set left margin",
	"^OM:   Read margin settings from current line",
	"^ON:   Toggle document mode",
	"^OO:   Reformat current paragraph",
	"^OR:   Set right margin",
	"^OT:   Toggle autoindent mode",
	"^OX:   Go to start of next paragraph",
	"^OZ:   Null this file's 'being edited' refcount",
	"^O?:   Display this screen",
	};

help(ch)
{
	static char botmes[] =
		"Use ^QH for more help. Press ENTER to continue ";

	clr_scrn();
	Printf("\t\t---  ^%c commands  ---\n\n", ch);

	switch (ch)
	{
	case 'K':
		dohelp(kmenu, sizeof(kmenu)/sizeof(*kmenu), botmes);
		break;
	case 'O':
		dohelp(omenu, sizeof(omenu)/sizeof(*omenu), botmes);
		break;
	case 'Q':
		dohelp(qmenu, sizeof(qmenu)/sizeof(*qmenu), botmes);
		break;
	}
}

dohelp(pp, n, botmes)
char **pp;
char *botmes;
{
	while (n--)
	{
		Printf("\t\t");
		emit(*pp++);
		Printf("\n");
	}
	gotoxy(0, height - 1);
 	Printf("%s", botmes);
	getaret();
	redhere();
}

getaret()
{
	char ch;
	/* Middle mouse hit returns zero */
	while (((ch = rawgetchar()) != '\r') && (ch != '\n') && ch)
		;
}

emit(str)
char *str;
{
	Printf("%s", str);
}
	
char *ctlhelp[] = {
	"ESC: Redisplay screen",
	"DEL: Delete character forwards",
	"INS: Toggle insert mode",
	"BS:  Delete character backwards",
	"^A:  Forward word",
	"^B:  Go to opposite end of line",
	"^C:  Down one page",
	"^D:  Forward one character",
	"^E:  Up one line",
	"^F:  Forward one word",
	"^G:  Delete character forwards",
	"^H:  Delete character backwards",
	"^J:  Go to start of next line",
	"^K:  Start a ^K command",
	"^L:  Repeat pattern search",
	"^N:  Repeat substitute",
	"^O:  Start a ^O command",
	"^P:  Insert a control character",
	"^Q:  Start a ^Q command",
	"^R:  Up one page",
	"^S:  Back one character",
	"^T:  Delete word forwards",
	"^V:  Delete back to start of line",
	"^W:  Scroll screen down",
	"^X:  Down one line",
	"^Y:  Delete current line",
	"^Z:  Scroll screen up",
	"^\\:  Toggle insert mode",
	"^UU: Put undo buffer 0",
	"^U0 - ^U9: Put an undo buffer"
	};

char *spclmenu[] = {
	"^B:  Toggle bold mode",
	"^E:  Toggle user code 1",
	"^Q:  Toggle user code 2",
	"^R:  Toggle user code 3",
	"^T:  Toggle superscript mode",
 	"^S:  Toggle underline mode",
	"^V:  Toggle subscript mode",
	"^W:  Toggle wide mode",
	"^Y:  Toggle italics mode"
	};

helpscreen()
{
	int xpos, ypos, index;
	int ypsave;

	clr_scrn();
	cprintf("---  Single control character commands  ---     ");
	ypos = 1;
	xpos = 0;
	for (index = 0; index < ASIZE(ctlhelp); index++)
	{
		if (index == (ASIZE(ctlhelp) + 1) / 2)
		{
			xpos = width / 2;
			ypos = 1;
		}
		gotoxy(xpos, ypos);
		emit(ctlhelp[index]);
		ypos++;
	}

	ypos++;
	gotoxy(0, ypos);
	cprintf("---  Special attribute characters (inserted with ^P) ---      ");
	ypos++;
	ypsave = ypos;
	xpos = 0;
	for (index = 0; index < ASIZE(spclmenu); index++)
	{
		if (index == (ASIZE(spclmenu) + 1) / 2)
		{
			xpos = width / 2;
			ypos = ypsave;
		}
		gotoxy(xpos, ypos);
		emit(spclmenu[index]);
		ypos++;
	}
	gotoxy(0, height - 1);
	Printf("Use ^K? or ^O? or ^Q? for more help. Press ENTER ");
	getaret();
	redhere();
}

cprintf(str, p1, p2, p3)
char *str;
{
	char buf[200];
	int i;

	sprintf(buf, str, p1, p2, p3);
	buf[width - 1] = 0;
	i = (width - strlen(buf)) / 2;
	while (i--)
		opchar(' ');
	Printf("%s", buf);
}
