/* TABS8 ex: set ts=8 sw=8: */

#include <stdio.h>
#include <sys/stat.h>
#include "../sedit.h"

/*
 * Return 0 if two pathnames refer to the same file
 */

pathcmp(p1, p2)
char *p1, *p2;
{
	char *pe1, *pe2;
	struct stat s1, s2;

	if (!strcmp(p1,p2))
		return 0;
	pe1 = patchenv(p1);
	pe2 = patchenv(p2);
	if (stat(pe1, &s1) < 0)
	{
		Free(pe1); Free(pe2);
		return -1;
	}
	if (stat(pe2, &s2) < 0)
	{
		Free(pe1); Free(pe2);
		return -1;
	}
	Free(pe1);
	Free(pe2);
	if (s1.st_dev == s2.st_dev && s1.st_ino == s2.st_ino)
	{
		return 0;
	}
	return 1;
}
