/* TABS4 */

#include "../sedit.h"

/*
 * Slice passed string into malloced substrings at *strs,
 * using space and tab as separators
 */

#define SEPARATOR(c) (((c) == ' ') || ((c) == '\t') || (colon && (c) == ':') || ((c) == 0))

int sliceargs(char *str, char ***strs, int canexpand, int colon)
{
	register char *s, *starts;
	char *copys;
	int nstrings;
	int insep;
	int pass;

	for (pass = 0; pass < 2; pass++)
	{
		starts = s = str;
		insep = 1;
		nstrings = 0;
		do
		{
			if (insep && !SEPARATOR(*s))
			{	/* separator->non separator */
				starts = s;
				nstrings++;
				insep = 0;
			}
			else if (!insep && SEPARATOR(*s))
			{	/* non-separator -> separator */
				if (pass == 1)
				{
					(*strs)[nstrings - 1] = Malloc(s - starts + 1);
					copys = (*strs)[nstrings - 1];
					while (starts < s)
						*copys++ = *starts++;
					*copys = '\0';
				}
				insep = 1;
			}
		}
		while (*s++);
		if (pass == 0)
		{
			*strs = zMalloc(nstrings * sizeof(*strs));
		}
	}
	return nstrings;
}

void cleanUpSlicedArgs(char **subStrings, int nstrings)
{
	int i;

	for (i = 0; i < nstrings; i++)
	{
		if (subStrings[i])
			Free(subStrings[i]);
	}
	Free(subStrings);
}

